## ros-indigo-jsk-recognition-utils 1.2.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(jsk_recognition_utils)

# Use ccache if installed to make it fast to generate object files
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

## Find catkin macros and libraries
## if COMPONENTS list like find_package(catkin REQUIRED COMPONENTS xyz)
## is used, also find other catkin packages
find_package(catkin REQUIRED COMPONENTS
  dynamic_reconfigure
  jsk_recognition_msgs
  pcl_ros
  pcl_msgs
  eigen_conversions
  message_generation
  rostest
  tf_conversions
  tf
  tf2_ros
  image_geometry
  sensor_msgs
  geometry_msgs
  jsk_topic_tools
  visualization_msgs
)

catkin_python_setup()

generate_dynamic_reconfigure_options(
  cfg/PoseArrayToPose.cfg
  cfg/PolygonArrayToPolygon.cfg
)

catkin_package(
 INCLUDE_DIRS include
 LIBRARIES jsk_recognition_utils
 CATKIN_DEPENDS jsk_recognition_msgs pcl_ros visualization_msgs message_runtime
)

# Cythonize pyx files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include(UseCython)
add_subdirectory(python/${PROJECT_NAME})

find_package(OpenCV REQUIRED core imgproc)
find_package(PCL REQUIRED)
find_package(PkgConfig)
pkg_check_modules(yaml_cpp yaml-cpp REQUIRED)
IF(${yaml_cpp_VERSION} VERSION_LESS "0.5.0")
## indigo yaml-cpp : 0.5.0 /  hydro yaml-cpp : 0.3.0
  add_definitions("-DUSE_OLD_YAML")
ENDIF()
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -z defs")
endif()
include_directories(
  include ${catkin_INCLUDE_DIRS}
)
link_libraries(${catkin_LIBRARIES} ${OpenCV_LIBRARIES} ${PCL_LIBRARIES} yaml-cpp)

add_library(jsk_recognition_utils SHARED
  src/grid_index.cpp
  src/grid_map.cpp
  src/grid_line.cpp
  src/geo_util.cpp
  src/random_util.cpp
  src/pcl_ros_util.cpp
  src/pcl_conversion_util.cpp
  src/pcl_util.cpp
  src/tf_listener_singleton.cpp
  src/pcl/ear_clipping_patched.cpp
  src/sensor_model_utils.cpp
  src/cv_utils.cpp
  src/rgb_colors.cpp
  src/geo/line.cpp
  src/geo/segment.cpp
  src/geo/polyline.cpp
  src/geo/plane.cpp
  src/geo/polygon.cpp
  src/geo/convex_polygon.cpp
  src/geo/cube.cpp
  src/geo/cylinder.cpp
  src/geo/grid_plane.cpp
  src/time_util.cpp
  )

if (CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest_gtest(test_tf_listener_singleton test/tf_listener_singleton.test src/tests/test_tf_listener_singleton.cpp)
  target_link_libraries(test_tf_listener_singleton ${PROJECT_NAME} ${catkin_LIBRARIES})
  catkin_add_gtest(test_cv_utils src/tests/test_cv_utils.cpp)
  target_link_libraries(test_cv_utils ${PROJECT_NAME} ${OpenCV_LIBRARIES})
  catkin_add_gtest(test_rgb_colors src/tests/test_rgb_colors.cpp)
  target_link_libraries(test_rgb_colors ${PROJECT_NAME} ${OpenCV_LIBRARIES})
  if("$ENV{ROS_DISTRO}" STRGREATER "hydro")
    # FIXME: jsk_tools/test_topic_published.py does not work on hydro travis/jenkins
    # https://github.com/jsk-ros-pkg/jsk_common/pull/1293#issuecomment-164158260
    add_rostest(sample/sample_add_bounding_box_array.launch ARGS gui:=false)
    add_rostest(sample/sample_bounding_box_array_publisher.launch ARGS gui:=false)
  endif()
endif()

# From https://github.com/jsk-ros-pkg/jsk_recognition/pull/2345
# Install header files directly into ${CATKIN_PACKAGE_INCLUDE_DESTINATION}.
# If the package has setup.py and modules under src/${PROJECT_NAME}/,
# install python executables directly into ${CATKIN_PACKAGE_BIN_DESTINATION}.
# However, if it doesn't have setup.py, directories including python executables
# should be installed recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Also, other directories like 'launch' or 'sample' must be installed
# recursively into ${CATKIN_PACKAGE_SHARE_DESTINATION}.
# Be careful that 'launch' and 'launch/' are different: the former is directory
# and the latter is each content.
install(TARGETS jsk_recognition_utils
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION})

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
)

install(DIRECTORY node_scripts sample test
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
  USE_SOURCE_PERMISSIONS
)

=== python/jsk_recognition_utils/CMakeLists.txt ===
if(NOT DEFINED Numpy_INCLUDE_DIRS)
  # Get Numpy include directories
  execute_process(
    COMMAND python -c "import sys, numpy; sys.stdout.write(numpy.get_include())"
    OUTPUT_VARIABLE Numpy_INCLUDE_DIRS
    RESULT_VARIABLE retcode)
  if(NOT ${retcode} EQUAL 0)
    message(FATAL_ERROR "Failed to get Numpy include dirs by numpy.get_include(). Exit code: ${retcode}")
  endif()
endif()
# Compile nms.pyx
include_directories(${Numpy_INCLUDE_DIRS})
cython_add_module(nms nms.pyx)
set_target_properties(nms PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION})
cython_add_module(color color.pyx)
set_target_properties(color PROPERTIES LIBRARY_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_PYTHON_DESTINATION})
install(TARGETS nms color
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_PYTHON_DESTINATION}
)

=== debian/changelog ===
ros-indigo-jsk-recognition-utils (1.2.7-0trusty) trusty; urgency=high

  * [jsk_perception] Add deep_sort_tracker_node.py (#2351 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2351> )
    * [jsk_recognition_utils/deep_sort_net.py] Renamed network name DeepSortFeature -> DeepSortFeatureExtractor
    * [jsk_perception/deep_sort/deep_sort_net.py] Moved to jsk_recognition_utils's chainermodels
  * [jsk_recognition_utils] Resolve dependency for chainer (#2306 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2306> )
  * Support passing Numpy_INCLUDE_DIRS externally (#2389 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2389> )
  * [doc] [jsk_perception] [jsk_recognition_utils] Add guide to image recognition with deep learning (#2365 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2365>)
    
      * Add doc for image annotation
      * Add annotate_images_with_labelme to index
      * Add dataset class for semantic segmentation
      * Add install_learning_datasets script
      * Download datasets during catkin build
      * Add .gitignore in learning_datasets/
      * Add train_fcn script
      * Set default learning_rate to valid value
      * Enable plotting from remote host as well
      * Add doc for training FCN
      * Add doc for starting deep learning with image dataset
      * Add how to create dataset, where to store it in documentation
      * Dump param for fcn_object_segmentation.py
      * Add InstanceSegmentationDataset
      * Add train script for Mask-RCNN
      * Fix model_name and outputs in train_fcn.md
      * Add doc for training Mask-RCNN
    
  * Contributors: Esteve Fernandez, Yuto Uchimi, Iori Yanokura

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Thu, 14 Feb 2019 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.6-0trusty) trusty; urgency=high

  * Install 'sample' and 'test'into SHARE_DESTINATION (#2345 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2345>)
  * Use diagnostic nodelet for EuclideanClustering and other nodelets (#2301 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2301>)
    * jsk_pcl_ros: euclidean_clustering: use dianogistc nodeletUse DiagnosticNodelet::updateDiagnostic preferrably
  * Describe the hierachy of rosparams of ClusterPointIndicesDecomposer (#2285 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2285>)
    * Fix test of add_bounding_box_array The input topics are slow (~1Hz), so slop should be larger (it was 0.1 before).
  * Fix for AssertionError in fast_rcnn.py (#2281 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2281>)
    * Use roi_pooling_2d defined in chainer for fast_rcnn on CPU mode
  * Re-enable tests which use chainer inside them (#2280 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2280>)
    * Looser timeout for test of add_bounding_box_array
  * Node to concatenate BoundingBoxArray (#2264 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2264>)
    * Doc for add_bounding_box_array.py
    * Node to concatenate BoundingBoxArray
    * Move <test> section to the sample launch files
  * Contributors: Yuki Furuta, Kei Okada, Kentaro Wada

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Fri, 02 Nov 2018 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.5-0trusty) trusty; urgency=high

  * Fix build of jsk_recognition_utils (on Kinetic) (#2262 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2262> )
    * Close https://github.com/jsk-ros-pkg/jsk_recognition/issues/2259
  * [jsk_perception/fast_rcnn.py] fast_rcnn node to follow chainer-v2 version (#2249 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2249>)
    * modify fast_rcnn model to follow chainer-v2 version
  * Contributors: Yuki Furuta, Kentaro Wada, Shingo Kitagawa

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Mon, 09 Apr 2018 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.4-0trusty) trusty; urgency=high

  * Add image gallery to README (#2225 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2225>)
  * Contributors: Kentaro Wada

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Fri, 12 Jan 2018 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.3-0trusty) trusty; urgency=high

  * Regional feature based object recognition using ResNet (#2172 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2172>)
  * Convert bounding box to mask (#2176 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2176>)
    * Add RectArrayToPolygonArray
  * Contributors: Kentaro Wada

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Thu, 23 Nov 2017 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.2-0trusty) trusty; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Sun, 23 Jul 2017 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.1-0trusty) trusty; urgency=high



 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Sat, 15 Jul 2017 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.2.0-0trusty) trusty; urgency=high

  * jsk_pcl_ros: Add Primitive shape classifier nodelet (#2141)
    
    jsk_recognition_utils/include/jsk_recognition_utils/geo/polygon.h
    
    [jsk_recognition_utils][polygon][fromROSMsg] use identity matrix for default transformation
  * jsk_recognition_utils/setup.py: Find packages automatically in jsk_recognition_utils (#2156 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2156>)
  * [jsk_recognition_utils] install chainermodels dir in setup.py (#2154 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2154>)
  * Contributors: Kentaro Wada, Shingo Kitagawa, Yuki Furuta

 -- Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>  Sat, 15 Jul 2017 00:00:00 -0000

ros-indigo-jsk-recognition-utils (1.1.3-0trusty) trusty; urgency=high

  * [jsk_pcl_ros_utils] Add nodelet for computing & comparing color  histogram (#2101 <https://github.com/jsk-ros-pkg/jsk_recognition/issues/2101> )
    * jsk_recognition_utils/include/jsk_recognition_utils/pcl/color_histogram.h: add color_histogram_classifier and visualizer


=== debian/control ===
Source: ros-indigo-jsk-recognition-utils
Section: misc
Priority: extra
Maintainer: Ryohei Ueda <ueda@jsk.t.u-tokyo.ac.jp>
Build-Depends: debhelper (>= 9.0.0), cython, libyaml-cpp-dev, ros-indigo-catkin, ros-indigo-dynamic-reconfigure, ros-indigo-eigen-conversions, ros-indigo-geometry-msgs, ros-indigo-image-geometry, ros-indigo-jsk-recognition-msgs, ros-indigo-jsk-tools, ros-indigo-jsk-topic-tools, ros-indigo-message-generation, ros-indigo-pcl-msgs, ros-indigo-pcl-ros, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-tf2-ros, ros-indigo-visualization-msgs
Homepage: http://jsk-docs.readthedocs.io/en/latest/jsk_recognition/jsk_recognition_utils
Standards-Version: 3.9.2

Package: ros-indigo-jsk-recognition-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libyaml-cpp-dev, python-skimage, ros-indigo-eigen-conversions, ros-indigo-geometry-msgs, ros-indigo-image-geometry, ros-indigo-jsk-recognition-msgs, ros-indigo-jsk-topic-tools, ros-indigo-message-runtime, ros-indigo-pcl-msgs, ros-indigo-pcl-ros, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf, ros-indigo-tf-conversions, ros-indigo-tf2-ros, ros-indigo-visualization-msgs
Description: C++ library about sensor model, geometrical modeling and perception.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-jsk-recognition-utils//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
